
#include "incscore.h"

#include "bzfs.h"


static int dummyID = 199;


//============================================================================//

static inline GameKeeper::Player* getPlayerByIndex(int playerID) {
  return GameKeeper::Player::getPlayerByIndex(playerID);
}

//============================================================================//

static void AddDummyPlayer(int playerID, const std::string& dummyName) {
  char callsign[CallSignLen] = { 0 };
  char email[EmailLen] = { 0 };
  strncpy(callsign, dummyName.c_str(), CallSignLen);

  void *buf, *buf0 = getDirectMessageBuffer();
  buf = buf0;

  buf = nboPackUByte(buf, dummyID);     // id
  buf = nboPackUShort(buf, TankPlayer); // type
  buf = nboPackUShort(buf, RogueTeam);  // team
  buf = nboPackUShort(buf, 0);          // wins
  buf = nboPackUShort(buf, 0);          // losses
  buf = nboPackUShort(buf, 0);          // tks
  buf = nboPackString(buf, callsign, CallSignLen);
  buf = nboPackString(buf, email,    EmailLen);
  const int bufLen = (char*)buf - (char*)buf0;

  directMessage(playerID, MsgAddPlayer, bufLen, buf0);
}


static void RemoveDummyPlayer(int playerID) {
  void *buf, *buf0 = getDirectMessageBuffer();
  buf = buf0;

  buf = nboPackUByte(buf, dummyID);
  const int bufLen = (char*)buf - (char*)buf0;

  directMessage(playerID, MsgRemovePlayer, bufLen, buf0);
}


static void DummyAlive(int playerID) {
  void *buf, *buf0 = getDirectMessageBuffer();
  buf = buf0;

  buf = nboPackUByte(buf, dummyID);
  buf = nboPackFloat(buf, 10000.0f); // pos.x
  buf = nboPackFloat(buf, 10000.0f); // pos.y
  buf = nboPackFloat(buf, 10000.0f); // pos.z
  buf = nboPackFloat(buf, 0.0f);     // forward
  const int bufLen = (char*)buf - (char*)buf0;

  directMessage(playerID, MsgAlive, bufLen, buf0);
}


static void DummyKilled(int playerID) {
  void *buf, *buf0 = getDirectMessageBuffer();
  buf = buf0;

  buf = nboPackUByte(buf, dummyID);  // victim
  buf = nboPackUByte(buf, playerID); // killer
  buf = nboPackShort(buf, 2);        // reason  (GotRunOver)
  buf = nboPackShort(buf, -1);       // shotID
  buf = nboPackShort(buf, 0);        // flagType
  const int bufLen = (char*)buf - (char*)buf0;

  directMessage(playerID, MsgKilled, bufLen, buf0);
}


//============================================================================//

void IncrementPlayerScore(int playerID, int count,
                          const std::string& dummyName) {
  if (count <= 0) {
    return;
  }

  GameKeeper::Player* gkPlayer = getPlayerByIndex(playerID);
  if (gkPlayer == NULL) {
    return;
  }

  // adjust the server's view of the score
  for (int i = 0; i < count; i++) {
    gkPlayer->score.kill();
  }

  // send the global score change
  void *buf, *buf0 = getDirectMessageBuffer();
  buf = buf0;
  buf = nboPackUByte(buf, 1);
  buf = nboPackUByte(buf, playerID);
  buf = gkPlayer->score.pack(buf);
  const int bufLen = (char*)buf - (char*)buf0;
  broadcastMessage(MsgScore, bufLen, buf0);

  // change the player's local score
  AddDummyPlayer(playerID, dummyName);
  for (int i = 0; i < count; i++) {
    DummyAlive(playerID);
    DummyKilled(playerID);
  }
  RemoveDummyPlayer(playerID);
}


//============================================================================//

